;===========================================================================================
; directxproc.asm    Nasm assembler  AsmGges France             http://www.chez.com/asmgges/
;===========================================================================================

;===========================================================================================
; Cration d'une surface
;-------------------------------------------------------------------------------------------
; AdrSurface = adresse de la variable qui va contenir l'adresse de la surface cre
; LSurface   = largeur de la surface en pixels
; HSurface   = hauteur de la surface en pixels
;===========================================================================================
proc CreateSurf, AdrSurface, LSurface, HSurface

    call ZeroMemory,ddsd,DDSURFACEDESC_size
    mov D[ddsd+DDSURFACEDESC.dwSize],DDSURFACEDESC_size
    mov D[ddsd+DDSURFACEDESC.dwFlags],DDSD_CAPS+DDSD_WIDTH+DDSD_HEIGHT
    mov D[ddsd+DDSURFACEDESC.ddsCaps],DDSCAPS_OFFSCREENPLAIN
    mov eax,[@LSurface]
    mov [ddsd+DDSURFACEDESC.dwWidth],eax
    mov eax,[@HSurface]
    mov [ddsd+DDSURFACEDESC.dwHeight],eax
    ddcall DD_CreateSurface,[DDraw],ddsd,[@AdrSurface],0

endproc
;===========================================================================================
; Remplir une surface avec une couleur
;-------------------------------------------------------------------------------------------
; NumSurf = [Nom] Surface  remplir
; Color   = couleur de remplissage format RGB 000000h
;===========================================================================================
proc FillSurface, NumSurf, Color

    call ZeroMemory,ddbltfx,DDBLTFX_size
    mov D[ddbltfx+DDBLTFX.dwSize],DDBLTFX_size
    mov eax,[@Color]
    mov [ddbltfx+DDBLTFX.dwFillColor],eax
    ddcall DDS_Blt,[@NumSurf],0,0,0,DDBLT_COLORFILL+DDBLT_WAIT,ddbltfx
    
endproc
;===========================================================================================
;                           Charger x.fichiers Gif87a et palette
;===========================================================================================
;
;Dans section .bss:
;    GifPal     resd 1
;    NbrBytes   resd 1
;    LBits      resb 1
;    LTable     resd 7676     
;    GifBuffer  resb 040000h  
;
;Exemple:
;    ;--------------------------
;    ; Charger un fichier gif87a
;    ;--------------------------
;    call LoadGif87a,picture,[DDSPicture]
;    or eax,eax
;    jnz near DataError
;
;    ;---------------------------
;    ; Charger une palette Gif87a
;    ;---------------------------
;    call LoadPalGif87a,picture
;    or eax,eax
;    jnz near DataError
;
;    ;------------------------------------
;    ; Palette Gif87a dans surface Primary
;    ;------------------------------------
;    ddcall DDS_SetPalette,[Primary],[GifPal]
;
;===========================================================================================
; Charger un fichier gif 87a noninterlaced
;-------------------------------------------------------------------------------------------
; Filename = adresse de la chaine-nom du fichier Gif87a noninterlaced
; Surface  = [Name] surface
;===========================================================================================
proc LoadGif87a, Filename, SurfaceDest

    invoke CreateFile,[@Filename],GENERIC_READ,0,0,OPEN_EXISTING,0,0
    or eax,eax
    jz near .GifError
    mov edi,eax

    invoke ReadFile,edi,GifBuffer,040000h,NbrBytes,0
    or eax,eax
    jz near .GifError

    invoke CloseHandle,edi
    or eax,eax
    jz near .GifError

    .if D[GifBuffer],ne,'GIF8'
        jmp near .GifError
    .endif

    .if W[GifBuffer+4],ne,'7a'
        jmp near .GifError
    .endif

    mov al,B[GifBuffer+10]
    and al,7
    .if al,ne,7
        jmp .GifError
    .endif

    add D[NbrBytes],GifBuffer
    mov esi,GifBuffer+781
    mov edi,esi

    .repeat
       .if esi,ae,[NbrBytes]
           jmp .GifError
       .endif
       lodsb
    .until al,e,44

    add esi,4
    mov eax,0
    lodsw
    mov ebx,eax
    lodsw
    add esi,2

    ddcall DDS_Lock,[@SurfaceDest],0,ddsd,DDLOCK_WAIT,0

    mov edi,esi
    mov edx,esi
    mov ebx,GifBuffer
    add ebx,[NbrBytes]

    .repeat
        .if esi,ae,[NbrBytes]
            jmp .GifError
        .endif
        lodsb
        movzx ecx,al
        rep movsb
    .until al,e,0

    mov edi,[ddsd+DDSURFACEDESC.lpSurface]
    mov ebx,edx
    mov B[LBits],0

.L0:
    mov edx,0

    .loop1:
         mov ch,9
         .if edx,a,2032
             mov ch,10
             .if edx,a,6128
                 mov ch,11
                 .if edx,a,14320
                     mov ch,12
                 .endif
             .endif
         .endif
         mov cl,B[LBits]
         mov eax,[ebx]
         shr eax,cl
         xchg ch,cl
         mov esi,1
         shl esi,cl
         dec esi
         and eax,esi
         add cl,ch

         .loop2:
              .if cl,be,8
                  jmp .L1
              .endif
              sub cl,8
              inc ebx
         jmp .loop2

         .L1:
         mov B[LBits],cl
         .if eax,ae,256
             .if eax,e,256
                 jmp .L0
             .endif
             sub eax,258
             js  .L2
             shl eax,3
             .if eax,a,edx
                 jmp .GifError
             .endif

             mov ecx,[LTable+eax]
             mov esi,[LTable+eax+4]
             mov [LTable+edx+4],edi
             rep movsb
             mov eax,[LTable+eax]
             inc eax
             mov [LTable+edx],eax

         .else
             mov D[LTable+edx],2
             mov [LTable+edx+4],edi
             stosb

         .endif

         add edx,8
    jmp .loop1

    .L2:
    ddcall DDS_Unlock,[@SurfaceDest],0

    ddcall DDS_SetColorKey,[@SurfaceDest],DDCKEY_SRCBLT,ddcolorkey
    or eax,eax
    jnz .GifError

    return

.GifError:
   mov eax,1
  
endproc
;===========================================================================================
; Charger une palette pour un fichier gif87a noninterlaced
;-------------------------------------------------------------------------------------------
; Filename = adresse de la chaine-nom du fichier gif87a noninterlaced
;===========================================================================================
proc LoadPalGif87a, Filename

    invoke CreateFile,[@Filename],GENERIC_READ,0,0,OPEN_EXISTING,0,0
    or eax,eax
    jz near .PalError

    mov edi,eax

    invoke ReadFile,edi,GifBuffer,781,NbrBytes,0
    .if D[NbrBytes],ne,781
        jmp .PalError
    .endif

    invoke CloseHandle,edi
    or eax,eax
    jz .PalError

    .if D[GifBuffer],ne,'GIF8'
        jmp .PalError
    .endif
    .if W[GifBuffer+4],ne,'7a'
        jmp .PalError
    .endif

    mov al,[GifBuffer+10]
    and al,7
    .if al,ne,7
        jmp .PalError
    .endif

    mov esi,GifBuffer+13
    mov edi,GifBuffer+1024
    mov ecx,256

    .loop1:
        movsw
        movsb
        mov al,0
        stosb
        dec ecx
    jnz .loop1

    ddcall DD_CreatePalette,[DDraw],DDPCAPS_8BIT+DDPCAPS_ALLOW256,GifBuffer+1024,GifPal,0
    or eax,eax
    jnz .PalError

    return

.PalError:
    mov eax,1
   
endproc
;===========================================================================================
;///////////////////////////////////////////////////////////////////////////////////////////
;===========================================================================================