;===========================================================================================
; generalproc.asm    Nasm assembler  AsmGges France             http://www.chez.com/asmgges/
;===========================================================================================

;===========================================================================================
; Mettre  zro une zone mmoire
;-------------------------------------------------------------------------------------------
; @AdrZone = adresse zone mmoire  mettre  zro
; @Len     = longueur de la zone en octets
;===========================================================================================
proc ZeroMemory, AdrZone, Len
    uses ecx,edi

    mov edi,[@AdrZone]
    mov ecx,[@Len]
    mov eax,0
    rep stosb

endproc
;===========================================================================================
; Limiter le nombre de frames par seconde
;-------------------------------------------------------------------------------------------
; @FpsMax = nombre de frames par secondes maximum
;-------------------------------------------------------------------------------------------
; Utilisation:
; invoke timeBeginPeriod,1    ;au dbut du programme
; mov [FpsMax],75
;
; invoke GetTickCount         ;dans MessageLoop
; mov [TickCount],eax
; call FpsLimiter,[FpsMax]
;
; invoke timeEndPeriod,1      ;a la fin du programme
;===========================================================================================
proc FpsLimiter, FpsMaxi
    %define .DelayTicks       ebp-4
    %define .MinTicksForSleep ebp-8
    sub esp,8
    uses ebx,edx 

    .if D[@FpsMaxi],e,0
        return
    .endif

    invoke QueryPerformanceFrequency,PerfFreq

    mov eax,D[PerfFreq]
    mov edx,D[PerfFreq+4]
    div D[@FpsMaxi]
    mov [.DelayTicks],eax

    mov eax,D[PerfFreq]
    mov edx,D[PerfFreq+4]
    mov ebx,500
    div ebx
    mov [.MinTicksForSleep],eax

    .L1:
        .repeat
            invoke QueryPerformanceCounter,PerfCounter
            mov eax,D[PerfCounter]
            mov edx,D[PerfCounter+4]
            .if edx,ne,[NextTimeEdx]
                jmp .finish
            .elseif eax,ae,[NextTimeEax]
                jmp .finish
            .endif
            mov ebx,[NextTimeEax]
            sub ebx,eax
        .until ebx,ae,[.MinTicksForSleep]
        push eax
        invoke Sleep,1
        pop eax
    jmp .L1

 .finish:
    add eax,[.DelayTicks]
    mov [NextTimeEax],eax
    mov [NextTimeEdx],edx

endproc
;===========================================================================================
;///////////////////////////////////////////////////////////////////////////////////////////
;===========================================================================================